__gnu_cxx::stdio_filebuf< _CharT, _Traits >(3)

NAME
__gnu_cxx::stdio_filebuf< _CharT, _Traits > -

SYNOPSIS

Inherits std::basic_filebuf< _CharT, _Traits >.

  Public Types
typedef codecvt< char_type,
char, __state_type > __codecvt_type"
typedef __basic_file< char > __file_type
typedef basic_filebuf
< char_type, traits_type > __filebuf_type"
typedef traits_type::state_type __state_type
typedef basic_streambuf
< char_type, traits_type > __streambuf_type"
typedef _CharT char_type
typedef traits_type::int_type int_type
typedef traits_type::off_type off_type
typedef traits_type::pos_type pos_type
typedef std::size_t size_t
typedef _Traits traits_type

  Public Member Functions
stdio_filebuf ()
stdio_filebuf (int __fd, std::ios_base::openmode __mode, size_t __size=static_cast< size_t >(BUFSIZ))
stdio_filebuf (std::__c_file *__f, std::ios_base::openmode __mode, size_t __size=static_cast< size_t >(BUFSIZ))
virtual ~stdio_filebuf ()
__filebuf_type * close ()
int fd ()
std::__c_file * file ()
locale getloc () const
streamsize in_avail ()
bool is_open () const throw ()
__filebuf_type * open (const char *__s, ios_base::openmode __mode)
__filebuf_type * open (const std::string &__s, ios_base::openmode __mode)
locale pubimbue (const locale &__loc)
int_type sbumpc ()
int_type sgetc ()
streamsize sgetn (char_type *__s, streamsize __n)
int_type snextc ()
int_type sputbackc (char_type __c)
int_type sputc (char_type __c)
streamsize sputn (const char_type *__s, streamsize __n)
int_type sungetc ()

basic_streambuf * pubsetbuf (char_type *__s, streamsize __n)
pos_type pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
pos_type pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
int pubsync ()

  Protected Member Functions
void __safe_gbump (streamsize __n)
void __safe_pbump (streamsize __n)
void _M_allocate_internal_buffer ()
bool _M_convert_to_external (char_type *, streamsize)
void _M_create_pback ()
void _M_destroy_internal_buffer () throw ()
void _M_destroy_pback () throw ()
int _M_get_ext_pos (__state_type &__state)
pos_type _M_seek (off_type __off, ios_base::seekdir __way, __state_type __state)
void _M_set_buffer (streamsize __off)
bool _M_terminate_output ()
void gbump (int __n)
virtual void imbue (const locale &__loc)
virtual int_type overflow (int_type __c=_Traits::eof())
virtual int_type pbackfail (int_type __c=_Traits::eof())
void pbump (int __n)
virtual pos_type seekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
virtual pos_type seekpos (pos_type __pos, ios_base::openmode __mode=ios_base::in|ios_base::out)
virtual __streambuf_type * setbuf (char_type *__s, streamsize __n)
void setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
void setp (char_type *__pbeg, char_type *__pend)
virtual streamsize showmanyc ()
virtual int sync ()
virtual int_type uflow ()
virtual int_type underflow ()
virtual streamsize xsgetn (char_type *__s, streamsize __n)
virtual streamsize xsputn (const char_type *__s, streamsize __n)

char_type * eback () const
char_type * gptr () const
char_type * egptr () const

char_type * pbase () const
char_type * pptr () const
char_type * epptr () const

  Protected Attributes
char_type * _M_buf
bool _M_buf_allocated
locale _M_buf_locale
size_t _M_buf_size
const __codecvt_type * _M_codecvt
char * _M_ext_buf
streamsize _M_ext_buf_size
char * _M_ext_end
const char * _M_ext_next
__file_type _M_file
char_type * _M_in_beg
char_type * _M_in_cur
char_type * _M_in_end
__c_lock _M_lock
ios_base::openmode _M_mode
char_type * _M_out_beg
char_type * _M_out_cur
char_type * _M_out_end
bool _M_reading
__state_type _M_state_beg
__state_type _M_state_cur
__state_type _M_state_last
bool _M_writing

char_type _M_pback
char_type * _M_pback_cur_save
char_type * _M_pback_end_save
bool _M_pback_init

Detailed Description

  template<typename _CharT, typename _Traits = std::char_traits<_CharT>>class __gnu_cxx::stdio_filebuf< _CharT, _Traits >
Provides a layer of compatibility for C/POSIX.

This GNU extension provides extensions for working with standard C FILE*'s and POSIX file descriptors. It must be instantiated by the user with the type of character used in the file stream, e.g., stdio_filebuf<char>.

Definition at line 50 of file stdio_filebuf.h.

Constructor & Destructor Documentation

  template<typename _CharT , typename _Traits = std::char_traits<_CharT>> __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf () [inline]
deferred initialization

Definition at line 65 of file stdio_filebuf.h.

  template<typename _CharT , typename _Traits > __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf (int__fd, std::ios_base::openmode__mode, size_t__size = static_cast<size_t>(BUFSIZ))

Parameters:
    __fd An open file descriptor.
    __mode Same meaning as in a standard filebuf.
    __size Optimal or preferred size of internal buffer, in chars.

This constructor associates a file stream buffer with an open POSIX file descriptor. The file descriptor will be automatically closed when the stdio_filebuf is closed/destroyed.

Definition at line 128 of file stdio_filebuf.h.

  template<typename _CharT , typename _Traits > __gnu_cxx::stdio_filebuf< _CharT, _Traits >::stdio_filebuf (std::__c_file *__f, std::ios_base::openmode__mode, size_t__size = static_cast<size_t>(BUFSIZ))

Parameters:
    __f An open FILE*.
    __mode Same meaning as in a standard filebuf.
    __size Optimal or preferred size of internal buffer, in chars. Defaults to system's BUFSIZ.

This constructor associates a file stream buffer with an open C FILE*. The FILE* will not be automatically closed when the stdio_filebuf is closed/destroyed.

Definition at line 144 of file stdio_filebuf.h.

  template<typename _CharT , typename _Traits > __gnu_cxx::stdio_filebuf< _CharT, _Traits >::~stdio_filebuf () [virtual]
Closes the external data stream if the file descriptor constructor was used.

Definition at line 123 of file stdio_filebuf.h.

Member Function Documentation

  template<typename _CharT, typename _Traits> void std::basic_filebuf< _CharT, _Traits >::_M_create_pback () [inline], [protected], [inherited]
Initializes pback buffers, and moves normal buffers to safety. Assumptions: _M_in_cur has already been moved back

Definition at line 177 of file fstream.

  template<typename _CharT, typename _Traits> void std::basic_filebuf< _CharT, _Traits >::_M_destroy_pback () [inline], [protected], [inherited]
Deactivates pback buffer contents, and restores normal buffer. Assumptions: The pback buffer has only moved forward.

Definition at line 194 of file fstream.

  template<typename _CharT, typename _Traits> void std::basic_filebuf< _CharT, _Traits >::_M_set_buffer (streamsize__off) [inline], [protected], [inherited]
This function sets the pointers of the internal buffer, both get and put areas. Typically:

__off == egptr() - eback() upon underflow/uflow (read mode); __off == 0 upon overflow (write mode); __off == -1 upon open, setbuf, seekoff/pos (uncommitted mode).

NB: epptr() - pbase() == _M_buf_size - 1, since _M_buf_size reflects the actual allocated memory and the last cell is reserved for the overflow char of a full put area.

Definition at line 395 of file fstream.

  template<typename _CharT , typename _Traits > basic_filebuf< _CharT, _Traits >::__filebuf_type * std::basic_filebuf< _CharT, _Traits >::close () [inherited]

Closes the currently associated file.

Returns:
    this on success, NULL on failure

If no file is currently open, this function immediately fails.

If a put buffer area exists, overflow(eof) is called to flush all the characters. The file is then closed.

If any operations fail, this function also fails.

Definition at line 128 of file fstream.tcc.

Referenced by std::basic_ifstream< _CharT, _Traits >::close(), std::basic_ofstream< _CharT, _Traits >::close(), std::basic_fstream< _CharT, _Traits >::close(), and std::basic_filebuf< char_type, traits_type >::~basic_filebuf().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::eback () const [inline], [protected], [inherited]

Access to the get area. These functions are only available to other protected functions, including derived classes.

•   eback() returns the beginning pointer for the input sequence

•   gptr() returns the next pointer for the input sequence

•   egptr() returns the end pointer for the input sequence

Definition at line 482 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_streambuf< char, char_traits< char > >::sputbackc(), and std::basic_streambuf< char, char_traits< char > >::sungetc().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::egptr () const [inline], [protected], [inherited]

Access to the get area. These functions are only available to other protected functions, including derived classes.

•   eback() returns the beginning pointer for the input sequence

•   gptr() returns the next pointer for the input sequence

•   egptr() returns the end pointer for the input sequence

Definition at line 488 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_streambuf< char, char_traits< char > >::in_avail(), std::basic_streambuf< char, char_traits< char > >::sbumpc(), std::basic_streambuf< char, char_traits< char > >::sgetc(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::showmanyc(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::str().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::epptr () const [inline], [protected], [inherited]

Access to the put area. These functions are only available to other protected functions, including derived classes.

•   pbase() returns the beginning pointer for the output sequence

•   pptr() returns the next pointer for the output sequence

•   epptr() returns the end pointer for the output sequence

Definition at line 535 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::sputc().

  template<typename _CharT , typename _Traits = std::char_traits<_CharT>> int __gnu_cxx::stdio_filebuf< _CharT, _Traits >::fd () [inline]

Returns:
    The underlying file descriptor.

Once associated with an external data stream, this function can be used to access the underlying POSIX file descriptor. Note that there is no way for the library to track what you do with the descriptor, so be careful.

Definition at line 109 of file stdio_filebuf.h.

  template<typename _CharT , typename _Traits = std::char_traits<_CharT>> std::__c_file* __gnu_cxx::stdio_filebuf< _CharT, _Traits >::file () [inline]

Returns:
    The underlying FILE*.

This function can be used to access the underlying 'C' file pointer. Note that there is no way for the library to track what you do with the file, so be careful.

Definition at line 119 of file stdio_filebuf.h.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> void std::basic_streambuf< _CharT, _Traits >::gbump (int__n) [inline], [protected], [inherited]

Moving the read position.

Parameters:
    __n The delta by which to move.

This just advances the read position without returning any data.

Definition at line 498 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::sbumpc(), std::basic_streambuf< char, char_traits< char > >::sputbackc(), std::basic_streambuf< char, char_traits< char > >::sungetc(), and std::basic_streambuf< char, char_traits< char > >::uflow().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> locale std::basic_streambuf< _CharT, _Traits >::getloc () const [inline], [inherited]

Locale access.

Returns:
    The current locale in effect.

If pubimbue(loc) has been called, then the most recent loc is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 226 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::pubimbue().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::gptr () const [inline], [protected], [inherited]

Access to the get area. These functions are only available to other protected functions, including derived classes.

•   eback() returns the beginning pointer for the input sequence

•   gptr() returns the next pointer for the input sequence

•   egptr() returns the end pointer for the input sequence

Definition at line 485 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_streambuf< char, char_traits< char > >::in_avail(), std::basic_streambuf< char, char_traits< char > >::sbumpc(), std::basic_streambuf< char, char_traits< char > >::sgetc(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::showmanyc(), std::basic_streambuf< char, char_traits< char > >::sputbackc(), std::basic_streambuf< char, char_traits< char > >::sungetc(), and std::basic_streambuf< char, char_traits< char > >::uflow().

  template<typename _CharT , typename _Traits > void std::basic_filebuf< _CharT, _Traits >::imbue (const locale &__loc) [protected], [virtual], [inherited]

Changes translations.

Parameters:
    __loc A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained.

Note:
    Base class version does nothing.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 910 of file fstream.tcc.

References std::ios_base::cur.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> streamsize std::basic_streambuf< _CharT, _Traits >::in_avail () [inline], [inherited]

Looking ahead into the stream.

Returns:
    The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived showmanyc().

Definition at line 284 of file streambuf.

  template<typename _CharT, typename _Traits> bool std::basic_filebuf< _CharT, _Traits >::is_open () const [inline], [inherited]

Returns true if the external file is open.

Definition at line 227 of file fstream.

Referenced by std::basic_ifstream< _CharT, _Traits >::is_open(), std::basic_ofstream< _CharT, _Traits >::is_open(), and std::basic_fstream< _CharT, _Traits >::is_open().

  template<typename _CharT , typename _Traits > basic_filebuf< _CharT, _Traits >::__filebuf_type * std::basic_filebuf< _CharT, _Traits >::open (const char *__s, ios_base::openmode__mode) [inherited]

Opens an external file.

Parameters:
    __s The name of the file.
    __mode The open mode flags.

Returns:
    this on success, NULL on failure

If a file is already open, this function immediately fails. Otherwise it tries to open the file named __s using the flags given in __mode.

Table 92, adapted here, gives the relation between openmode combinations and the equivalent fopen() flags. (NB: lines app, in|out|app, in|app, binary|app, binary|in|out|app, and binary|in|app per DR 596) +---------------------------------------------------------+ | ios_base Flag combination stdio equivalent | |binary in out trunc app | +---------------------------------------------------------+ | + w | | + + a | | + a | | + + w | | + r | | + + r+ | | + + + w+ | | + + + a+ | | + + a+ | +---------------------------------------------------------+ | + + wb | | + + + ab | | + + ab | | + + + wb | | + + rb | | + + + r+b | | + + + + w+b | | + + + + a+b | | + + + a+b | +---------------------------------------------------------+

Definition at line 94 of file fstream.tcc.

References std::ios_base::ate, std::ios_base::end, and std::basic_filebuf< _CharT, _Traits >::open().

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), std::basic_filebuf< char_type, traits_type >::open(), std::basic_ifstream< _CharT, _Traits >::open(), std::basic_ofstream< _CharT, _Traits >::open(), and std::basic_fstream< _CharT, _Traits >::open().

  template<typename _CharT, typename _Traits> __filebuf_type* std::basic_filebuf< _CharT, _Traits >::open (const std::string &__s, ios_base::openmode__mode) [inline], [inherited]

Opens an external file.

Parameters:
    __s The name of the file.
    __mode The open mode flags.

Returns:
    this on success, NULL on failure

Definition at line 280 of file fstream.

  template<typename _CharT , typename _Traits > basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::overflow (int_type__c = _Traits::eof()) [protected], [virtual], [inherited]

Consumes data from the buffer; writes to the controlled sequence.

Parameters:
    __c An additional character to consume.

Returns:
    eof() to indicate failure, something else (usually __c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is consumed, with some effect on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if __c is not eof().

For a formal definition of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note:
    Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 422 of file fstream.tcc.

References std::ios_base::cur, and std::ios_base::out.

  template<typename _CharT , typename _Traits > basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::pbackfail (int_type__c = _Traits::eof()) [protected], [virtual], [inherited]

Tries to back up the input sequence.

Parameters:
    __c The character to be inserted back into the sequence.

Returns:
    eof() on failure, some other value on success

Postcondition:
    The constraints of gptr(), eback(), and pptr() are the same as for underflow().

Note:
    Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 363 of file fstream.tcc.

References std::ios_base::cur, and std::ios_base::in.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::pbase () const [inline], [protected], [inherited]

Access to the put area. These functions are only available to other protected functions, including derived classes.

•   pbase() returns the beginning pointer for the output sequence

•   pptr() returns the next pointer for the output sequence

•   epptr() returns the end pointer for the output sequence

Definition at line 529 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::str().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> void std::basic_streambuf< _CharT, _Traits >::pbump (int__n) [inline], [protected], [inherited]

Moving the write position.

Parameters:
    __n The delta by which to move.

This just advances the write position without returning any data.

Definition at line 545 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::sputc().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::pptr () const [inline], [protected], [inherited]

Access to the put area. These functions are only available to other protected functions, including derived classes.

•   pbase() returns the beginning pointer for the output sequence

•   pptr() returns the next pointer for the output sequence

•   epptr() returns the end pointer for the output sequence

Definition at line 532 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::sputc(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::str().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> locale std::basic_streambuf< _CharT, _Traits >::pubimbue (const locale &__loc) [inline], [inherited]

Entry point for imbue().

Parameters:
    __loc The new locale.

Returns:
    The previous locale.

Calls the derived imbue(__loc).

Definition at line 209 of file streambuf.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> pos_type std::basic_streambuf< _CharT, _Traits >::pubseekoff (off_type__off, ios_base::seekdir__way, ios_base::openmode__mode = ios_base::in | ios_base::out) [inline], [inherited]

Alters the stream position.

Parameters:
    __off Offset.
    __way Value for ios_base::seekdir.
    __mode Value for ios_base::openmode.

Calls virtual seekoff function.

Definition at line 251 of file streambuf.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> pos_type std::basic_streambuf< _CharT, _Traits >::pubseekpos (pos_type__sp, ios_base::openmode__mode = ios_base::in | ios_base::out) [inline], [inherited]

Alters the stream position.

Parameters:
    __sp Position
    __mode Value for ios_base::openmode.

Calls virtual seekpos function.

Definition at line 263 of file streambuf.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> basic_streambuf* std::basic_streambuf< _CharT, _Traits >::pubsetbuf (char_type *__s, streamsize__n) [inline], [inherited]

Entry points for derived buffer functions. The public versions of pubfoo dispatch to the protected derived foo member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 239 of file streambuf.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> int std::basic_streambuf< _CharT, _Traits >::pubsync () [inline], [inherited]

Calls virtual sync function.

Definition at line 271 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::sync().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> int_type std::basic_streambuf< _CharT, _Traits >::sbumpc () [inline], [inherited]

Getting the next character.

Returns:
    The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns uflow().

Definition at line 316 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::istreambuf_iterator< _CharT, _Traits >::operator++(), and std::basic_streambuf< char, char_traits< char > >::snextc().

  template<typename _CharT , typename _Traits > basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::seekoff (off_type, ios_base::seekdir, ios_base::openmode = ios_base::in | ios_base::out) [protected], [virtual], [inherited]

Alters the stream positions. Each derived class provides its own appropriate behavior.

Note:
    Base class version does nothing, returns a pos_type that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 713 of file fstream.tcc.

References std::ios_base::cur.

  template<typename _CharT , typename _Traits > basic_filebuf< _CharT, _Traits >::pos_type std::basic_filebuf< _CharT, _Traits >::seekpos (pos_type, ios_base::openmode = ios_base::in | ios_base::out) [protected], [virtual], [inherited]

Alters the stream positions. Each derived class provides its own appropriate behavior.

Note:
    Base class version does nothing, returns a pos_type that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 773 of file fstream.tcc.

References std::ios_base::beg.

  template<typename _CharT , typename _Traits > basic_filebuf< _CharT, _Traits >::__streambuf_type * std::basic_filebuf< _CharT, _Traits >::setbuf (char_type *__s, streamsize__n) [protected], [virtual], [inherited]

Manipulates the buffer.

Parameters:
    __s Pointer to a buffer area.
    __n Size of __s.

Returns:
    this

If no file has been opened, and both __s and __n are zero, then the stream becomes unbuffered. Otherwise, __s is used as a buffer; see http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt11ch25s02.html for more.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 684 of file fstream.tcc.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> void std::basic_streambuf< _CharT, _Traits >::setg (char_type *__gbeg, char_type *__gnext, char_type *__gend) [inline], [protected], [inherited]

Setting the three read area pointers.

Parameters:
    __gbeg A pointer.
    __gnext A pointer.
    __gend A pointer.

Postcondition:
    __gbeg == eback(), __gnext == gptr(), and __gend == egptr()

Definition at line 509 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), and std::basic_filebuf< char_type, traits_type >::_M_set_buffer().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> void std::basic_streambuf< _CharT, _Traits >::setp (char_type *__pbeg, char_type *__pend) [inline], [protected], [inherited]

Setting the three write area pointers.

Parameters:
    __pbeg A pointer.
    __pend A pointer.

Postcondition:
    __pbeg == pbase(), __pbeg == pptr(), and __pend == epptr()

Definition at line 555 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_set_buffer().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> int_type std::basic_streambuf< _CharT, _Traits >::sgetc () [inline], [inherited]

Getting the next character.

Returns:
    The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns underflow(). Does not move the read position after fetching the character.

Definition at line 338 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::sentry::sentry(), and std::basic_streambuf< char, char_traits< char > >::snextc().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> streamsize std::basic_streambuf< _CharT, _Traits >::sgetn (char_type *__s, streamsize__n) [inline], [inherited]

Entry point for xsgetn.

Parameters:
    __s A buffer area.
    __n A count.

Returns xsgetn(__s,__n). The effect is to fill __s[0] through __s[__n-1] with characters from the input sequence, if possible.

Definition at line 357 of file streambuf.

  template<typename _CharT , typename _Traits > streamsize std::basic_filebuf< _CharT, _Traits >::showmanyc () [protected], [virtual], [inherited]

Investigating the data available.

Returns:
    An estimate of the number of characters available in the input sequence, or -1.

If it returns a positive value, then successive calls to underflow() will not return traits::eof() until at least that number of characters have been supplied. If showmanyc() returns -1, then calls to underflow() or uflow() will fail. [27.5.2.4.3]/1

Note:
    Base class version does nothing, returns zero.

    The standard adds that the intention is not only that the calls [to underflow or uflow] will not return eof() but that they will return immediately.

    The standard adds that the morphemes of showmanyc are es-how-many-see, not show-manic.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 178 of file fstream.tcc.

References std::ios_base::binary, and std::ios_base::in.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> int_type std::basic_streambuf< _CharT, _Traits >::snextc () [inline], [inherited]

Getting the next character.

Returns:
    The next character, or eof.

Calls sbumpc(), and if that function returns traits::eof(), so does this function. Otherwise, sgetc().

Definition at line 298 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), and std::basic_istream< _CharT, _Traits >::sentry::sentry().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> int_type std::basic_streambuf< _CharT, _Traits >::sputbackc (char_type__c) [inline], [inherited]

Pushing characters back into the input stream.

Parameters:
    __c The character to push back.

Returns:
    The previous character, if possible.

Similar to sungetc(), but __c is pushed onto the stream instead of the previous character. If successful, the next character fetched from the input stream will be __c.

Definition at line 372 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::putback().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> int_type std::basic_streambuf< _CharT, _Traits >::sputc (char_type__c) [inline], [inherited]

Entry point for all single-character output functions.

Parameters:
    __c A character to output.

Returns:
    __c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores __c in that position, increments the position, and returns traits::to_int_type(__c). If a write position is not available, returns overflow(__c).

Definition at line 424 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::get(), and std::ostreambuf_iterator< _CharT, _Traits >::operator=().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> streamsize std::basic_streambuf< _CharT, _Traits >::sputn (const char_type *__s, streamsize__n) [inline], [inherited]

Entry point for all single-character output functions.

Parameters:
    __s A buffer read area.
    __n A count.

One of two public output functions.

Returns xsputn(__s,__n). The effect is to write __s[0] through __s[__n-1] to the output sequence, if possible.

Definition at line 450 of file streambuf.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> int_type std::basic_streambuf< _CharT, _Traits >::sungetc () [inline], [inherited]

Moving backwards in the input stream.

Returns:
    The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to unget the last character gotten.

Definition at line 397 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::unget().

  template<typename _CharT , typename _Traits > int std::basic_filebuf< _CharT, _Traits >::sync () [protected], [virtual], [inherited]

Synchronizes the buffer arrays with the controlled sequences.

Returns:
    -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of failure.

Note:
    Base class version does nothing, returns zero.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 893 of file fstream.tcc.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> virtual int_type std::basic_streambuf< _CharT, _Traits >::uflow () [inline], [protected], [virtual], [inherited]

Fetches more data from the controlled sequence.

Returns:
    The first character from the pending sequence.

Informally, this function does the same thing as underflow(), and in fact is required to call that function. It also returns the new character, like underflow() does. However, this function also moves the read position forward by one.

Reimplemented in __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >.

Definition at line 700 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::sbumpc().

  template<typename _CharT , typename _Traits > basic_filebuf< _CharT, _Traits >::int_type std::basic_filebuf< _CharT, _Traits >::underflow () [protected], [virtual], [inherited]

Fetches more data from the controlled sequence.

Returns:
    The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is refilled. In either case, the next available character is returned, or traits::eof() to indicate a null pending sequence.

For a formal definition of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see http://gcc.gnu.org/onlinedocs/libstdc++/manual/bk01pt11ch25.html

Note:
    Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 204 of file fstream.tcc.

References std::ios_base::in, and std::min().

  template<typename _CharT , typename _Traits > streamsize std::basic_filebuf< _CharT, _Traits >::xsgetn (char_type *__s, streamsize__n) [protected], [virtual], [inherited]

Multiple character extraction.

Parameters:
    __s A buffer area.
    __n Maximum number of characters to assign.

Returns:
    The number of characters assigned.

Fills __s[0] through __s[__n-1] with characters from the input sequence, as if by sbumpc(). Stops when either __n characters have been copied, or when traits::eof() would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 549 of file fstream.tcc.

References std::ios_base::in.

  template<typename _CharT , typename _Traits > streamsize std::basic_filebuf< _CharT, _Traits >::xsputn (const char_type *__s, streamsize__n) [protected], [virtual], [inherited]

Multiple character insertion.

Parameters:
    __s A buffer area.
    __n Maximum number of characters to write.

Returns:
    The number of characters written.

Writes __s[0] through __s[__n-1] to the output sequence, as if by sputc(). Stops when either n characters have been copied, or when sputc() would return traits::eof().

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 637 of file fstream.tcc.

References std::min(), and std::ios_base::out.

Member Data Documentation

  template<typename _CharT, typename _Traits> char_type* std::basic_filebuf< _CharT, _Traits >::_M_buf [protected], [inherited]

Pointer to the beginning of internal buffer.

Definition at line 114 of file fstream.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), and std::basic_filebuf< char_type, traits_type >::_M_set_buffer().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> locale std::basic_streambuf< _CharT, _Traits >::_M_buf_locale [protected], [inherited]

Current locale setting.

Definition at line 192 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::basic_filebuf(), std::basic_streambuf< char, char_traits< char > >::getloc(), and std::basic_streambuf< char, char_traits< char > >::pubimbue().

  template<typename _CharT, typename _Traits> size_t std::basic_filebuf< _CharT, _Traits >::_M_buf_size [protected], [inherited]
Actual size of internal buffer. This number is equal to the size of the put area + 1 position, reserved for the overflow char of a full area.

Definition at line 121 of file fstream.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_set_buffer().

  template<typename _CharT, typename _Traits> char* std::basic_filebuf< _CharT, _Traits >::_M_ext_buf [protected], [inherited]
Buffer for external characters. Used for input when codecvt::always_noconv() == false. When valid, this corresponds to eback().

Definition at line 156 of file fstream.

  template<typename _CharT, typename _Traits> streamsize std::basic_filebuf< _CharT, _Traits >::_M_ext_buf_size [protected], [inherited]
Size of buffer held by _M_ext_buf.

Definition at line 161 of file fstream.

  template<typename _CharT, typename _Traits> const char* std::basic_filebuf< _CharT, _Traits >::_M_ext_next [protected], [inherited]
Pointers into the buffer held by _M_ext_buf that delimit a subsequence of bytes that have been read but not yet converted. When valid, _M_ext_next corresponds to egptr().

Definition at line 168 of file fstream.

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_beg [protected], [inherited]

Start of get area.

Definition at line 184 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::eback(), and std::basic_streambuf< char, char_traits< char > >::setg().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_cur [protected], [inherited]

Current read area.

Definition at line 185 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::gbump(), std::basic_streambuf< char, char_traits< char > >::gptr(), and std::basic_streambuf< char, char_traits< char > >::setg().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_end [protected], [inherited]

End of get area.

Definition at line 186 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::egptr(), and std::basic_streambuf< char, char_traits< char > >::setg().

  template<typename _CharT, typename _Traits> ios_base::openmode std::basic_filebuf< _CharT, _Traits >::_M_mode [protected], [inherited]

Place to stash in || out || in | out settings for current filebuf.

Definition at line 99 of file fstream.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_set_buffer().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_beg [protected], [inherited]

Start of put area.

Definition at line 187 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::pbase(), and std::basic_streambuf< char, char_traits< char > >::setp().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_cur [protected], [inherited]

Current put area.

Definition at line 188 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::pbump(), std::basic_streambuf< char, char_traits< char > >::pptr(), and std::basic_streambuf< char, char_traits< char > >::setp().

  template<typename _CharT, typename _Traits = char_traits<_CharT>> char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_end [protected], [inherited]

End of put area.

Definition at line 189 of file streambuf.

Referenced by std::basic_streambuf< char, char_traits< char > >::epptr(), and std::basic_streambuf< char, char_traits< char > >::setp().

  template<typename _CharT, typename _Traits> char_type std::basic_filebuf< _CharT, _Traits >::_M_pback [protected], [inherited]
Necessary bits for putback buffer management.

Note:
    pbacks of over one character are not currently supported.

Definition at line 142 of file fstream.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback().

  template<typename _CharT, typename _Traits> char_type* std::basic_filebuf< _CharT, _Traits >::_M_pback_cur_save [protected], [inherited]
Necessary bits for putback buffer management.

Note:
    pbacks of over one character are not currently supported.

Definition at line 143 of file fstream.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), and std::basic_filebuf< char_type, traits_type >::_M_destroy_pback().

  template<typename _CharT, typename _Traits> char_type* std::basic_filebuf< _CharT, _Traits >::_M_pback_end_save [protected], [inherited]
Necessary bits for putback buffer management.

Note:
    pbacks of over one character are not currently supported.

Definition at line 144 of file fstream.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), and std::basic_filebuf< char_type, traits_type >::_M_destroy_pback().

  template<typename _CharT, typename _Traits> bool std::basic_filebuf< _CharT, _Traits >::_M_pback_init [protected], [inherited]
Necessary bits for putback buffer management.

Note:
    pbacks of over one character are not currently supported.

Definition at line 145 of file fstream.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), and std::basic_filebuf< char_type, traits_type >::_M_destroy_pback().

  template<typename _CharT, typename _Traits> bool std::basic_filebuf< _CharT, _Traits >::_M_reading [protected], [inherited]
_M_reading == false && _M_writing == false for uncommitted mode; _M_reading == true for read mode; _M_writing == true for write mode;

NB: _M_reading == true && _M_writing == true is unused.

Definition at line 133 of file fstream.

Author

Generated automatically by Doxygen for libstdc++ from the source code.